# Milestones

## Hello screen again

  - [x] Extract OpenGL
  - [x] Minimal Vulkan
  - [x] ImGui

## Hello other

  - [x] Multiplayer
  - [~] Chat
    - Private messages
  - [~] Authentication
  - [x] Compression
  - [x] Encryption
  - [x] Embedded
  - [x] Standalone

## Hello world

  - [~] Map stream
    - [ ] Modifications compression
    - [ ] Local prediction
  - [ ] Contouring service
  - [~] Edit
    - [x] Shape iterators
    - [ ] Anchor
    - [x] Prevent suffocation
    - [ ] Local prediction
  - [~] Occlusion Culling
    - [ ] Iterator ray
    - [ ] Cast from chunk center
  - [x] Transparency
  - [~] Entities
    - [ ] Collide
    - [ ] Get models
  - [ ] Reduce compile unit count
  - [ ] Review documentation
  - [ ] Clean kick

## Hello universe

  - [ ] CI build
    - CMake package
    - GitLab / Drone pipeline
  - [ ] Universe
    - [ ] Galaxy
      - [ ] Rotation
      - [ ] Orbit system
      - [ ] Gravity referential
    - [ ] Better generation
      - SIMD
        - [ ] Dynamic SIMD libs
        - [ ] FastNoiseSIMD / HastyNoise double precision
        - [ ] https://github.com/Auburn/FastNoise2/releases
      - [ ] Surface features
      - [ ] Biomes
        - https://imgur.com/kM8b5Zq
        - https://imgur.com/a/bh2iy
        - https://speciesdevblog.files.wordpress.com/2012/11/biomemap.png
  - [ ] Planet scale LOD
  - [~] Curvature
    - [~] CubeSphere
      - [ ] Area corrected CubeSphere
      - [ ] Corrected Normals
      - [ ] Surface curvature
      - [ ] Curvature avare frustum
    - [ ] Healpix

## Hello industry

 - [ ] Multiblock
 - [ ] Inventory

## Hello darkness

  - [ ] Break area part to entity
  - [ ] Slash screen
  - [ ] Start/Pause menu
  - [x] QUIC protocol
  - [ ] 8 for 1 contouring problem
  - [ ] Use in memory protocol (to replace server_handle)
  - [ ] Octree
    - [ ] Better Lod
  - [ ] VK
    - [ ] Instanced draw
    - [ ] Pipeline cache
    - [ ] Reuse descriptors
    - [ ] Secondary buffers
  - [ ] ECS
  - [ ] Cross plateforme encoding
  - [ ] Config (yaml)
  - [ ] HDR
    - https://www.youtube.com/watch?v=iikdcAA7cww
    - Toon shading
    - Eye adaptation
  - [ ] Correct sRGB conversions
  - [ ] Post processing
    - https://learnopengl.com/Advanced-OpenGL/Anti-Aliasing
    - Bloom
  - [ ] Procedural Skybox
  - [ ] Deferred
  - [ ] Cascaded shadow maps
  - [ ] Ray Tracing
  - [ ] Translucency
    - Back face Depth based
